



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MongoDB数据库中更新与删除数据</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MongoDB数据库中更新与删除数据</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 01:25:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>MongoDB数据库中更新与删除数据</p>
<p>在MongoDB数据库中，可以使用Collection对象的update方法更新集合中的数据文档。使用方法如下所示：</p>
<div>
<pre class="prettyprint linenums">collection.update(selector, document, [options], [callback]);</pre>
</div>
<p><strong>selector参数</strong>：该参数值为一个对象，用于查询需要更新的数据文档。该参数值指定的方法和我们前面使用的find方法中使用的selector参数值的指定方法完全相同。</p>
<p><strong>document参数</strong>：该参数值为一个对象，用于指定用来更新的数据文档。</p>
<p><strong>options参数：</strong>该参数值为一个对象，用于指定更新数据时使用的选项，下面介绍几个常用的选项属性：<br />&nbsp; 1. upsert 该属性值是一个布尔值，用于指定是否在跟新数据时执行upsert操作，所谓upsert操作是指当被更新的数据文档不存在时插入一条数据<br />文档的操作。该属性值默认为false。</p>
<p><strong>2. multi:</strong> 该属性值也是一个布尔值，用于指定是否更新所有符合查询条件的数据文档。默认值为false(只更新第一条符合查询条件的数据文档)。</p>
<p><strong>callback参数</strong>：用于指定更新数据操作执行结束时执行的回调函数，该回调函数的指定方法如下所示：</p>
<div>
<pre class="prettyprint linenums">function(err, result){};</pre>
</div>
<p>err参数为更新数据操作失败时抛出的错误对象，result参数值为一个整数值，代表成功更新的数据条数，当更新数据操作失败时该属性值为null。</p>
<p>首先我们还是一样先查看数据库中users集合中的所有数据如下，使用代码如下：</p>
<div>
<pre class="prettyprint linenums">const mongo = require('mongodb');<br />
const Server = mongo.Server;<br />
const Db = mongo.Db;

const server = new Server('localhost', '27017', { auto_reconnect: true });<br />
const db = new Db('dataDb', server, { safe: true });

db.open(function(err, db) {<br />
  if (err) {<br />
    throw err;<br />
  } else {<br />
    console.log('成功建立数据库连接');<br />
    db.collection('users', function(err, collection) {<br />
      if (err) {<br />
        throw err;<br />
      } else {<br />
        // 开始查询集合users<br />
        collection.find({}).toArray(function(err, docs) {<br />
          if (err) {<br />
            throw err;<br />
          } else {<br />
            console.log(docs);<br />
            db.close();<br />
          }<br />
        });<br />
      }<br />
    });<br />
  }<br />
});</pre>
</div>
<p>如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223355182-650348048.png" /></p>
<p>然后现在我们使用update方法来更新上面的数据，我想把 userName='空智'的数据更新成'龙恩0707'，使用方法如下：</p>
<div>
<pre class="prettyprint linenums">collection.update({}, {userName: '龙恩0707'});</pre>
</div>
<p>如下所有的代码：</p>
<div>
<pre class="prettyprint linenums">const mongo = require('mongodb');<br />
const Server = mongo.Server;<br />
const Db = mongo.Db;

const server = new Server('localhost', '27017', { auto_reconnect: true });<br />
const db = new Db('dataDb', server, { safe: true });

db.open(function(err, db) {<br />
  if (err) {<br />
    throw err;<br />
  } else {<br />
    console.log('成功建立数据库连接');<br />
    db.collection('users', function(err, collection) {<br />
      if (err) {<br />
        throw err;<br />
      } else {<br />
        // 开始查询集合users<br />
        collection.update({}, {userName: '龙恩0707'}, function(err, result) {<br />
          if (err) {<br />
            throw err;<br />
          } else {<br />
            collection.find({}).toArray(function(err, docs) {<br />
              if (err) {<br />
                throw err;<br />
              } else {<br />
                console.log('更新后的数据：');<br />
                console.log(docs);<br />
                db.close();<br />
              }<br />
            });<br />
          }<br />
        })<br />
      }<br />
    });<br />
  }<br />
});</pre>
</div>
<p>执行运行结果如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223451202-672082992.png" /></p>
<p>如上可以看到只更新了第一条数据，那是因为options对象中的属性multi默认为false，如果需要更改所有的数据的话，需要指定options中的multi属性为true即可。需要在document参数值对象中使用$set原子操作符。</p>
<p>如下更改代码：</p>
<div>
<pre class="prettyprint linenums">collection.update({}, {$set: {userName: '龙恩0707'}}, {multi: true}, function(err, result) {});</pre>
</div>
<p>如下所有代码：</p>
<div>
<pre class="prettyprint linenums">const mongo = require('mongodb');<br />
const Server = mongo.Server;<br />
const Db = mongo.Db;

const server = new Server('localhost', '27017', { auto_reconnect: true });<br />
const db = new Db('dataDb', server, { safe: true });

db.open(function(err, db) {<br />
  if (err) {<br />
    throw err;<br />
  } else {<br />
    console.log('成功建立数据库连接');<br />
    db.collection('users', function(err, collection) {<br />
      if (err) {<br />
        throw err;<br />
      } else {<br />
        // 开始查询集合users<br />
        collection.update({}, {$set: {userName: '龙恩0707'}}, {multi: true}, function(err, result) {<br />
          if (err) {<br />
            throw err;<br />
          } else {<br />
            collection.find({}).toArray(function(err, docs) {<br />
              if (err) {<br />
                throw err;<br />
              } else {<br />
                console.log('更新后的数据：');<br />
                console.log(docs);<br />
                db.close();<br />
              }<br />
            });<br />
          }<br />
        })<br />
      }<br />
    });<br />
  }<br />
});</pre>
</div>
<p>运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223547042-2054187165.png" /></p>
<p><strong>3. 理解options对象中的upsert属性</strong><br />如果将options参数值对象中的upsert属性值指定为true，那么会当集合中不存在符合查询条件的数据文档时，会将把document参数值对象插入到集合中。<br />现在我们再来看看在update方法中更新一条userName字段为 'aaa'的数据文档，users集合中不存在该数据文档的，他会将把update方法中指定<br />document参数值对象插入到users集合中。如下代码：</p>
<div>
<pre class="prettyprint linenums">collection.update({userName: 'aaa'}, {userName: 'aaa'}, {upsert: true}, function(err, result) {});</pre>
</div>
<p>执行结果如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223636623-653735303.png" /></p>
<p>可以看到在窗口中显示users集合中被插入一条数据aaa;</p>
<p><strong>4. remove()方法删除集合中的数据文档</strong><br />该方法是删除集合中的数据文档，该方法使用如下所示：</p>
<div>
<pre class="prettyprint linenums">collection.remove([selector], [options], [callback]);</pre>
</div>
<p><strong>selector参数</strong>用于查询需要删除的数据文档。<br /><strong>options参数</strong>值为一个对象，用于指定删除数据时使用的选项. 常用的选项属性值如下：<br />  <strong>single</strong>: 属性值为一个布尔值，用于指定是否只删除第一条满足查询条件的数据文档，默认属性值为false。</p>
<p><strong>callback参数</strong>用于指定更新数据操作执行结束时执行的回调函数，该回调函数指定的方法如下所示：</p>
<div>
<pre class="prettyprint linenums">function(err, result) {}</pre>
</div>
<p>err参数为删除数据操作失败时抛出的错误对象。result参数值为一个整数值，代表成功删除的数据条数，当删除数据失败时该属性值为null.</p>
<p>如下的demo，首选往goods这个集合中插入数据后，然后在删除前查询下数据有多少，查询完成后，继续执行删除操作，删除条件就是所有 price<br />为11的都删除掉；如下所有代码所示：</p>
<div>
<pre class="prettyprint linenums">const mongo = require('mongodb');<br />
const Server = mongo.Server;<br />
const Db = mongo.Db;

const server = new Server('localhost', '27017', { auto_reconnect: true });<br />
const db = new Db('dataDb', server, { safe: true });<br />
var docs = [<br />
  {type: 'food', price: 11},<br />
  {type: 'food', price: 10},<br />
  {type: 'food', price: 9},<br />
  {type: 'food', price: 8},<br />
  {type: 'food', price: 7},<br />
];<br />
db.open(function(err, db) {<br />
  if (err) {<br />
    throw err;<br />
  } else {<br />
    console.log('成功建立数据库连接');<br />
    db.collection('goods', function(err, collection) {<br />
      collection.insert(docs, function(err, docs) {<br />
        if (err) {<br />
          throw err;<br />
        } else {<br />
          collection.find({}).toArray(function(err, docs) {<br />
            if (err) {<br />
              throw err;<br />
            } else {<br />
              console.log('删除前的goods集合中的数据为如下：');<br />
              console.log(docs);<br />
            }<br />
          });<br />
        }<br />
      });<br />
      collection.remove({price: 11}, function(err, result) {<br />
        if (err) {<br />
          throw err;<br />
        } else {<br />
          collection.find({}).toArray(function(err, docs) {<br />
            if (err) {<br />
              throw err;<br />
            } else {<br />
              console.log('删除后的数据为:');<br />
              console.log(docs);<br />
              db.close();<br />
            }<br />
          });<br />
        }<br />
      });<br />
    });<br />
  }<br />
});</pre>
</div>
<p>如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223821879-182064773.png" /></p>
<p>由于options参数对象中的single属性值默认为false，因此将删除所有满足查询条件的数据文档，如果将该属性值设置为true，那么将只删除第一条满足条件的数据文档。如下代码：</p>
<div>
<pre class="prettyprint linenums">collection.remove({price: 10}, {single: true}, function(err, result) {});</pre>
</div>
<p>如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/561794/201806/561794-20180628223906671-1860580136.png" /></p>
<p><strong>5. findAndRemove方法查询并删除一条数据文档</strong><br />   使用该方法可以查询并删除一条数据文档，该方法使用方式如下所示：</p>
<div>
<pre class="prettyprint linenums">collection.findAndRemove(selector, sort, [options], callback);</pre>
</div>
<p>selector参数值为一个对象，用于查询需要删除的数据文档；<br />   sort参数值为一个数组，用于指定当存在多条符合查询条件的数据文档时这些数据的排序方式。该数组包含两个元素，每个元素都为一个数组，<br />   第一个元素值为用于排序的字段名，第二个元素值可以为1或-1，1 是升序， -1是降序。<br />   options值为一个对象，用于指定删除数据时使用的选项属性。<br />   callback参数 用于指定删除数据操作时结束执行的回调函数，该回调函数指定方法如下所示：</p>
<div>
<pre class="prettyprint linenums">function(err, doc) {}</pre>
</div>
<p>err参数值为删除数据操作失败时抛出的错误对象。<br />   doc参数值为一个对象，代表删除的数据文档，当删除数据失败时该属性值为null。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyyrr2q.html">SSH实战  &amp;&num;183&semi;  AJAX异步校验</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0p53q.html">linux命令之 用户和群组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5xze8.html">Sqoop导入mysql数据到Hbase</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd50ydq.html">POJ 3104</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12jz39.html">HDU 5858 Hard problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6myvq.html">通过代码设置button中文字的对齐方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5wvm8.html">&lowbar;&lowbar;call方法简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6x0e9.html">学c语言做练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/950y40m8.html">PLSQL Developer软件使用大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506zr68.html">GWAS文献解读：The stability of educational achievement across school years is largely explained by genetic factors</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2j660q.html">Android Call requires API level 19 &lpar;current min is 15&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1v2k1q.html">maven项目配置框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jl665q.html">OpenCV-Python基本功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2gm26q.html">BZOJ1899或洛谷2577 &lbrack;ZJOI2005&rsqb;午餐</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emyp4x9.html">如何随机获取数据库不连续ID的数据？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emmwzz9.html">安装redis出现cc adlist&period;o &sol;bin&sol;sh&colon;1&colon;cc&colon;not found</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pn4v08.html">vue-cli 打包报错：Unexpected token&colon; punc &lpar;&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwp10q.html">docker 删除none镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppo7579.html">Backing up the tail</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvemp219.html">S EAI 客户主数据导入&lowbar;test&lpar;detail&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv27rno9.html">Apollo源码阅读笔记（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1x2k49.html">Java - BlockingQueue</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzw7k8.html">CSS-高度塌陷问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xypoq.html">安装 kubernetes v1&period;11&period;1</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xy1rq.html">&lbrack;总结&rsqb;jQuery之选择器集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwxgnx9.html">图的遍历（bfs&plus;dfs）模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4xr0x9.html">CSS中的行内元素和块级元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjxry79.html">html标签必备</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xvroq.html">JavaScript大杂烩3 - 理解JavaScript对象的封装性</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w61o0q.html">cropper实现基本的裁剪图片并上传</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
